unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, math, Spin, gridfunctions, Menus, FPCFunctions;

type
  TForm1 = class(TForm)
    Options: TListBox;
    Footprints: TListBox;
    Board: TListBox;
    Cutouts: TListBox;
    Parts: TListBox;
    nets: TListBox;
    Texts: TListBox;
    Label7: TLabel;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    StringGrid1: TStringGrid;
    Button3: TButton;
    Button4: TButton;
    SpinEdit1: TSpinEdit;
    Label8: TLabel;
    PopupMenu1: TPopupMenu;
    DeleteItem1: TMenuItem;
    Move1: TMenuItem;
    Up1: TMenuItem;
    Down1: TMenuItem;
    SaveBuild1: TMenuItem;
    LoadBuild1: TMenuItem;
    OpenDialog2: TOpenDialog;
    SaveDialog2: TSaveDialog;
    CreateRotatedVersion1: TMenuItem;
    N901: TMenuItem;
    N11: TMenuItem;
    N2701: TMenuItem;
    Label9: TLabel;
    Label10: TLabel;
    N01: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    Label3: TLabel;
    SetRepeatCount1: TMenuItem;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure DeleteItem1Click(Sender: TObject);
    procedure Up1Click(Sender: TObject);
    procedure Down1Click(Sender: TObject);
    procedure SaveBuild1Click(Sender: TObject);
    procedure LoadBuild1Click(Sender: TObject);
    procedure N901Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure N2701Click(Sender: TObject);
    procedure N01Click(Sender: TObject);
    procedure SetRepeatCount1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}

Procedure ProcessOptions(List:TstringList;prepend:string);
begin
  list.Delete(0);
  form1.Options.Items.CommaText := list.CommaText;
end;

Procedure ProcessFootprints(List:TstringList;prepend:string);
var
  line:integer;
  temp:string;
begin
  for line := 1 to list.Count -1 do
  begin
    temp := list[line];
    if pos('name: "',list[line])= 1 then
      insert(prepend,temp,8);
    form1.Footprints.Items.Add(temp);
  end;
end;

Procedure ProcessBoard(List:TstringList;prepend:string);
begin
  form1.Board.Items.Clear;
  Form1.Board.Items.Add('');
  Form1.Board.Items.Add('outline: 0');
end;

procedure ProcessCutouts(List:TstringList;prepend:string;Xoffset,Yoffset:int64);
var
  line:integer;
  temp:string;
  exploded:tstringlist;
begin
  for line := 1 to list.Count -1 do
  begin
    temp := list[line];
    if pos('  corner: ',temp) = 1 then
    begin
      exploded := explode(temp,' ');
      exploded[4] := inttostr(strtoint(exploded[4])+xoffset);
      exploded[5] := inttostr(strtoint(exploded[5])+yoffset);
      temp := implode (exploded,' ');
      exploded.Free;
    end;
    form1.Cutouts.Items.Add(temp);
  end;
end;

procedure ProcessParts(List:TstringList;prepend:string;Xoffset,Yoffset:int64);
var
  line:integer;
  temp:string;
  exploded:tstringlist;
begin
  for line := 1 to list.Count -1 do
  begin
    temp := list[line];
    if pos('part: ',temp) = 1 then
      insert(prepend,temp,7);
    if pos('  shape: "',temp) = 1 then
      insert(prepend,temp,11);
    if pos('  pos: ',temp) = 1 then
    begin
      exploded := explode(temp,' ');
      exploded[3] := inttostr(strtoint(exploded[3])+xoffset);
      exploded[4] := inttostr(strtoint(exploded[4])+yoffset);
      temp := implode(exploded,' ');
      exploded.Free;
    end;
    form1.Parts.Items.Add(temp);
  end;
end;

procedure ProcessNets(List:TstringList;prepend:string;Xoffset,Yoffset:int64);
var
  line:integer;
  temp:string;
  ch:integer;
  exploded:Tstringlist;
begin
  for line := 1 to list.Count -1 do
  begin
    temp := list[line];
    if pos('net: "',temp) = 1 then
      insert(prepend,temp,7);
    if pos('  pin: ',temp) = 1 then
    begin
      ch := 8;
      while temp[ch] <> ' ' do
        inc(ch);
      insert(prepend,temp,ch+1);
    end;
    if pos('    vtx: ',temp) = 1then
    begin
      exploded := explode(temp,' ');
      exploded[6] := inttostr(strtoint(exploded[6])+xoffset);
      exploded[7] := inttostr(strtoint(exploded[7])+yoffset);
      temp := implode(exploded,' ');
    end;
    if pos('    corner: ',temp) = 1 then
    begin
      exploded := explode(temp,' ');
      exploded[6] := inttostr(strtoint(exploded[6])+xoffset);
      exploded[7] := inttostr(strtoint(exploded[7])+yoffset);
      temp := implode(exploded,' ');
    end;

    form1.Nets.Items.Add(temp);
  end;
end;

procedure ProcessTexts(List:TstringList;prepend:string;Xoffset,Yoffset:int64);
var
  line:integer;
  temp:string;
  exploded:tstringlist;
begin
  for line := 1 to list.Count -1 do
  begin
    temp := list[line];
    if length(trim(temp)) > 0 then
    begin
      exploded := explode(temp,' ');
      exploded[exploded.Count-7] := inttostr(strtoint(exploded[exploded.Count-7])+xoffset);
      exploded[exploded.Count-6] := inttostr(strtoint(exploded[exploded.Count-6])+yoffset);
      temp := implode(exploded,' ');
      exploded.Free;
    end;
    form1.Texts.Items.Add(temp);
  end;
end;

{Procedure ProcessFile(Filename:String;Prepend:string;Xoffset,Yoffset:int64);
var
  List:TstringList;
  F:Textfile;
  line:string;
begin
  List := tstringList.create;
  Assignfile(f,filename);
  reset(f);
  while not eof(f) do
  begin
    readln(f,line);
    if length(line) > 0 then
      if (line[1] = '[') and (list.Count > 0) then
      begin
        while list[list.Count-1] = '' do
          list.Delete(list.Count-1);
        if list[0] = '[options]' then
          ProcessOptions(list,prepend);
        if list[0] = '[footprints]' then
          ProcessFootprints(list,prepend);
        if list[0] = '[board]' then
          ProcessBoard(list,prepend);
        if list[0] = '[solder_mask_cutouts]' then
          ProcessCutouts(list,prepend, xoffset, Yoffset);
        if list[0] = '[parts]' then
          ProcessParts(list,prepend, Xoffset,Yoffset);
        if list[0] = '[nets]' then
          Processnets(list,prepend, xoffset,yOffset);
        if list[0] = '[texts]' then
          ProcessTexts(list,prepend, xoffset,yoffset);
        list.Clear;
      end;
    list.Add(line);
  end;
  closefile(f);
end;}

Procedure ProcessFile(Lines:TstringList;Prepend:string;Xoffset,Yoffset:int64);
var
  List:TstringList;
  line:string;
  c:integer;
begin
  List := tstringList.create;
  begin
    for c := 0 to lines.count -2 do
    begin
      list.add(lines[c]);
      if length(lines[c+1]) > 0 then
        if lines[c+1][1] = '[' then
        begin
          while list[list.Count-1] = '' do
            list.Delete(list.Count-1);
          if list[0] = '[options]' then
            ProcessOptions(list,prepend);
          if list[0] = '[footprints]' then
            ProcessFootprints(list,prepend);
          if list[0] = '[board]' then
            ProcessBoard(list,prepend);
          if list[0] = '[solder_mask_cutouts]' then
            ProcessCutouts(list,prepend, xoffset, Yoffset);
          if list[0] = '[parts]' then
            ProcessParts(list,prepend, Xoffset,Yoffset);
          if list[0] = '[nets]' then
            Processnets(list,prepend, xoffset,yOffset);
          if list[0] = '[texts]' then
            ProcessTexts(list,prepend, xoffset,yoffset);
          list.Clear;
        end;
    end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  c:integer;
  f:textfile;
begin
  if savedialog1.Execute then
  begin
    assignfile(f,savedialog1.filename);
    rewrite(F);
    writeln(F,'[options]');
    for c := 0 to options.Items.Count-1 do
      writeln(f,options.items[c]);
    writeln(F,'');
    writeln(F,'[footprints]');
    for c := 0 to footprints.Items.Count-1 do
      writeln(f,footprints.items[c]);
    writeln(F,'');
    writeln(F,'[board]');
    for c := 0 to board.Items.Count-1 do
      writeln(f,board.items[c]);
    writeln(F,'');
    writeln(F,'[solder_mask_cutouts]');
    for c := 0 to cutouts.Items.Count-1 do
      writeln(f,cutouts.items[c]);
    writeln(F,'');
    writeln(F,'[parts]');
    for c := 0 to parts.Items.Count-1 do
      writeln(f,parts.items[c]);
    writeln(F,'');
    writeln(F,'[nets]');
    for c := 0 to nets.Items.Count-1 do
      writeln(f,nets.items[c]);
    writeln(F,'');
    writeln(F,'[texts]');
    for c := 0 to texts.Items.Count-1 do
      writeln(f,texts.items[c]);
    writeln(F,'');
    writeln(F,'[end]');
    closefile(f);
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  stringgrid1.ColWidths[0]:= 512;
  left := (screen.Width - form1.Width) div 2;
  top := (screen.Height - form1.Height) div 2;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  c:integer;
  Board_Extents:Trect;
  Lines:Tstringlist;
begin
  If opendialog1.Execute then
  begin
    for c := 0 to opendialog1.Files.Count -1 do
    begin
      lines := tstringlist.Create;
      lines.loadfromfile(opendialog1.files[c]);
      Board_Extents := Get_Board_Extents(lines);
      lines.Free;
      if Board_Extents.Left = high(Board_extents.left) then
        showmessage('File: '+opendialog1.files[c]+' does not have a board outline.  It will not be added')
      else
      begin
        if stringgrid1.Cells[0,stringGrid1.RowCount-1] <> '' then
          stringgrid1.RowCount := stringGrid1.RowCount +1;
        stringGrid1.Cells[0,StringGrid1.RowCount-1] := opendialog1.Files[c];
        stringGrid1.cells[1,StringGrid1.RowCount-1] := '0';
        stringGrid1.cells[2,StringGrid1.RowCount-1] := '1';
      end;
    end;
  end;
end;

Procedure incString(var str:String);
var
  temp:char;
  c:integer;
begin
  temp := str[length(str)];
  if temp <'Z' then
  begin
    inc(temp);
    str[length(str)] := temp;
  end
  else
  begin
    for c:= 1 to length(str) do
      str[c] := 'A';
    str := str+'A';
  end;
end;



procedure TForm1.Button4Click(Sender: TObject);
var
  c:integer;
  runningx,runningy,xoffset,yoffset :int64;
  Prependstr:string;
  lines:tstringlist;
  r:trect;
  reps:integer;
  rotations:integer;
  CurrentColWidth:integer;
begin
  lines:=tstringlist.create;
  runningy := 0;
  runningx := 0;
  currentcolwidth:=0;
  options.Items.Clear;
  footprints.Items.Clear;
  board.Items.Clear;
  cutouts.Items.Clear;
  parts.Items.Clear;
  nets.Items.Clear;
  texts.Items.Clear;
  Prependstr := 'A';
  For c:= 0 to stringGrid1.RowCount -1 do
    for reps := 1 to strtoint(stringGrid1.cells[2,c]) do
    begin
      lines := tstringlist.Create;
      lines.LoadFromFile(stringgrid1.Cells[0,c]);
      for rotations := 0 to (strtoint(stringGrid1.cells[1,c]) div 90)-1 do
        rotate90(lines);
      R := Get_Board_Extents(lines);
      if spinedit3.value > 0 then
        if RunningY+r.Top-r.Bottom > (spinedit3.value*25400) then
        begin
          if currentcolwidth = 0 then
          begin
            showmessage('Your maximum height is too small to accomodate one or more of your boards.  Process terminated');
            exit;
          end;
          runningx := currentcolwidth+ (spinedit2.value*25400)+runningx;
          runningy :=0;
          currentcolwidth := 0;
        end;
      xoffset := (r.left*-1)+runningX;
      yoffset := (r.bottom*-1)+runningy;
      processfile(lines,prependstr+'_',xoffset,yoffset);
      Runningy := runningY+r.top-r.bottom+(spinedit1.Value * 25400);
      currentcolwidth := max(currentcolwidth,r.Right-r.Left);
      incstring(prependstr);
      lines.Free;
    end;
  button2click(sender);
end;

procedure TForm1.DeleteItem1Click(Sender: TObject);
begin
  deleterow(StringGrid1,StringGrid1.Row);
end;

procedure TForm1.Up1Click(Sender: TObject);
begin
  MoveRowUp(StringGrid1,StringGrid1.row);
end;

procedure TForm1.Down1Click(Sender: TObject);
begin
  MoveRowDown(StringGrid1,StringGrid1.Row);
end;

procedure TForm1.SaveBuild1Click(Sender: TObject);
begin
  if savedialog2.Execute then
    SaveGrid(StringGrid1,SaveDialog2.filename);
end;

procedure TForm1.LoadBuild1Click(Sender: TObject);
begin
  if opendialog2.Execute then
    LoadGrid(StringGrid1,opendialog2.FileName);
end;

procedure TForm1.N901Click(Sender: TObject);
begin
  if stringgrid1.Row > -1 then
    stringGrid1.Cells[1,stringGRid1.Row] := '90';
end;

procedure TForm1.N11Click(Sender: TObject);
begin
  if stringgrid1.Row > -1 then
    stringGrid1.Cells[1,stringGRid1.Row] := '180';
end;

procedure TForm1.N2701Click(Sender: TObject);
begin
  if stringgrid1.Row > -1 then
    stringGrid1.Cells[1,stringGRid1.Row] := '270';
end;

procedure TForm1.N01Click(Sender: TObject);
begin
  if stringgrid1.Row > -1 then
    stringGrid1.Cells[1,stringGRid1.Row] := '0';
end;

procedure TForm1.SetRepeatCount1Click(Sender: TObject);
begin
  if stringGrid1.Row <> -1 then
  begin
    Form2.spinedit1.Value := strtoint(stringGRid1.Cells[2,stringGrid1.row]);
    if form2.showmodal = mrok then
      stringGRid1.Cells[2,stringGrid1.row] := inttostr(form2.SpinEdit1.value);
  end;
end;

end.
